commit dd081f9869df90ab7f7d7911c1bdd3ef976f1439
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Wed Oct 29 12:13:09 2025 +0000

    constify

diff --git a/src/src/acl.c b/src/src/acl.c
index 36fb850c8..7d07ab698 100644
--- a/src/src/acl.c
+++ b/src/src/acl.c
@@ -3939,7 +3939,7 @@ for (; cb; cb = cb->next)
       /* See comment on ACLC_SPF wrt. coding issues */
       {
       misc_module_info * mi = misc_mod_find(US"dmarc", &log_message);
-      typedef uschar * (*efn_t)(int);
+      typedef const uschar * (*efn_t)(void);
       const uschar * expanded_query;
 
       if (!mi)
@@ -3956,8 +3956,7 @@ for (; cb; cb = cb->next)
       view into the process in the future. */
 
       /*XXX is this call used with any other arg? */
-      expanded_query = (((efn_t *) mi->functions)[DMARC_EXPAND_QUERY])
-						      (DMARC_VERIFY_STATUS);
+      expanded_query = (((efn_t *) mi->functions)[DMARC_EXPAND_QUERY]) ();
       rc = match_isinlist(expanded_query,
 			  &arg, 0, NULL, NULL, MCL_STRING, TRUE, NULL);
       }
diff --git a/src/src/functions.h b/src/src/functions.h
index 98dc1a461..4801eb8b5 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -374,15 +374,17 @@ extern int     misc_mod_msg_init(void);
 extern void    misc_mod_smtp_reset(void);
 
 extern uschar *moan_check_errorcopy(const uschar *);
-extern BOOL    moan_skipped_syntax_errors(uschar *, error_block *, uschar *,
-                 BOOL, uschar *);
+extern BOOL    moan_skipped_syntax_errors(const uschar *, const error_block *,
+		const uschar *, BOOL, const uschar *);
 extern void    moan_smtp_batch(const uschar *, const char *, ...)
 		  PRINTF_FUNCTION(2,3);
-extern BOOL    moan_send_message(const uschar *, int, error_block *eblock,
-		 header_line *, FILE *, const uschar *);
-extern void    moan_tell_someone(const uschar *, address_item *,
-                 const uschar *, const char *, ...) PRINTF_FUNCTION(4,5);
-extern BOOL    moan_to_sender(int, error_block *, header_line *, FILE *, BOOL);
+extern BOOL    moan_send_message(const uschar *, int,
+		const error_block * eblock, const header_line *,
+		FILE *, const uschar *);
+extern void    moan_tell_someone(const uschar *, const address_item *,
+                const uschar *, const char *, ...) PRINTF_FUNCTION(4,5);
+extern BOOL    moan_to_sender(int, const error_block *, const header_line *,
+		FILE *, BOOL);
 extern void    moan_write_from(FILE *);
 extern void    moan_write_references(FILE *, uschar *);
 #ifdef LOOKUP_MODULE_DIR
diff --git a/src/src/miscmods/dmarc.c b/src/src/miscmods/dmarc.c
index bc96607e0..185ef9f4f 100644
--- a/src/src/miscmods/dmarc.c
+++ b/src/src/miscmods/dmarc.c
@@ -60,10 +60,10 @@ static dmarc_exim_p dmarc_policy_description[] = {
 /* $variables */
 BOOL	 dmarc_alignment_dkim	 = FALSE; /* Subtest result */
 BOOL	 dmarc_alignment_spf	 = FALSE; /* Subtest result */
-uschar * dmarc_domain_policy     = NULL; /* Declared policy of used domain */
-uschar * dmarc_status            = NULL; /* One word value */
-uschar * dmarc_status_text       = NULL; /* Human readable value */
-uschar * dmarc_used_domain       = NULL; /* Domain libopendmarc chose for DMARC policy lookup */
+const uschar * dmarc_domain_policy = NULL; /* Declared policy of used domain */
+const uschar * dmarc_status;		/* One word value */
+const uschar * dmarc_status_text   = NULL; /* Human readable value */
+uschar * dmarc_used_domain;		/* Domain libopendmarc chose for DMARC policy lookup */
 
 /* options */
 uschar * dmarc_forensic_sender   = NULL; /* Set sender address for forensic reports */
@@ -108,9 +108,9 @@ end, and append the two strings passed to it.  Used for adding
 variable amounts of value:pair data to the forensic emails. */
 
 static error_block *
-add_to_eblock(error_block *eblock, uschar *t1, uschar *t2)
+add_to_eblock(error_block * eblock, const uschar * t1, const uschar * t2)
 {
-error_block *eb = store_malloc(sizeof(error_block));
+error_block * eb = store_malloc(sizeof(error_block));
 if (!eblock)
   eblock = eb;
 else
@@ -645,10 +645,7 @@ The EDITME provides a DMARC_API variable */
   libdm_status = opendmarc_policy_fetch_p(dmarc_pctx, &tmp_ans);
   for (c = 0; dmarc_policy_description[c].name; c++)
     if (tmp_ans == dmarc_policy_description[c].value)
-      {
-      dmarc_domain_policy = string_sprintf("%s",dmarc_policy_description[c].name);
-      break;
-      }
+      { dmarc_domain_policy = dmarc_policy_description[c].name; break; }
 
   /* Can't use exim's string manipulation functions so allocate memory
   for libopendmarc using its max hostname length definition. */
@@ -743,23 +740,19 @@ if (!f.dmarc_disable_verify)
 return OK;
 }
 
-static uschar *
-dmarc_exim_expand_defaults(int what)
+static const uschar *
+dmarc_exim_expand_defaults(void)
 {
-if (what == DMARC_VERIFY_STATUS)
-  return f.dmarc_disable_verify ?  US"off" : US"none";
-return US"";
+return f.dmarc_disable_verify ?  US"off" : US"none";
 }
 
-static uschar *
-dmarc_exim_expand_query(int what)
+static const uschar *
+dmarc_exim_expand_query(void)
 {
 if (f.dmarc_disable_verify || !dmarc_pctx)
-  return dmarc_exim_expand_defaults(what);
+  return dmarc_exim_expand_defaults();
 
-if (what == DMARC_VERIFY_STATUS)
-  return dmarc_status;
-return US"";
+return dmarc_status;
 }
 
 
diff --git a/src/src/moan.c b/src/src/moan.c
index efac33681..5635f93e2 100644
--- a/src/src/moan.c
+++ b/src/src/moan.c
@@ -159,8 +159,9 @@ Returns:         TRUE if message successfully sent
 */
 
 BOOL
-moan_send_message(const uschar * recipient, int ident, error_block * eblock,
-  header_line * headers, FILE * message_file, const uschar * firstline)
+moan_send_message(const uschar * recipient, int ident,
+  const error_block * eblock, const header_line * headers,
+  FILE * message_file, const uschar * firstline)
 {
 int written = 0, fd, status, count = 0, size_limit = bounce_return_size_limit;
 FILE * fp;
@@ -389,7 +390,7 @@ if (bounce_return_message)
 
   while (headers)
     {
-    if (headers->text != NULL) fprintf(fp, "%s", CS headers->text);
+    if (headers->text) fprintf(fp, "%s", CS headers->text);
     headers = headers->next;
     }
 
@@ -494,8 +495,8 @@ Returns:        FALSE if there is no sender_address to send to;
 */
 
 BOOL
-moan_to_sender(int ident, error_block *eblock, header_line *headers,
-  FILE *message_file, BOOL check_sender)
+moan_to_sender(int ident, const error_block * eblock,
+  const header_line * headers, FILE * message_file, BOOL check_sender)
 {
 uschar *firstline = NULL;
 uschar *msg = US"Error while reading message with no usable sender address";
@@ -601,7 +602,7 @@ Returns:        nothing
 */
 
 void
-moan_tell_someone(const uschar * who, address_item * addr,
+moan_tell_someone(const uschar * who, const address_item * addr,
   const uschar * subject, const char * format, ...)
 {
 FILE * f;
@@ -814,14 +815,14 @@ Returns:            FALSE if string expansion failed; TRUE otherwise
 */
 
 BOOL
-moan_skipped_syntax_errors(uschar *rname, error_block *eblock,
-  uschar *syntax_errors_to, BOOL some, uschar *custom)
+moan_skipped_syntax_errors(const uschar * rname, const error_block * eblock,
+  const uschar * syntax_errors_to, BOOL some, const uschar * custom)
 {
 int pid, fd;
 const uschar * s;
 FILE * f;
 
-for (error_block * e = eblock; e; e = e->next)
+for (const error_block * e = eblock; e; e = e->next)
   if (e->text2)
     log_write(0, LOG_MAIN, "%s router: skipped error: %s in %q",
       rname, e->text1, e->text2);
@@ -870,11 +871,10 @@ if (custom)
 fprintf(f, "The %s router encountered the following error(s):\n\n",
   rname);
 
-for (error_block * e = eblock; e; e = e->next)
+for (const error_block * e = eblock; e; e = e->next)
   {
   fprintf(f, "  %s", e->text1);
-  if (e->text2 != NULL)
-    fprintf(f, " in the address\n  \"%s\"", e->text2);
+  if (e->text2) fprintf(f, " in the address\n  \"%s\"", e->text2);
   fprintf(f, "\n\n");
   }
 
diff --git a/src/src/structs.h b/src/src/structs.h
index 147819dd5..a6261afcb 100644
--- a/src/src/structs.h
+++ b/src/src/structs.h
@@ -680,8 +680,8 @@ typedef struct {
 
 typedef struct error_block {
   struct error_block *next;
-  const uschar *text1;
-  uschar *text2;
+  const uschar * text1;
+  const uschar * text2;
 } error_block;
 
 /* Chain of file names when processing the queue */

